//
// DeltaReason.swift
//
// Generated by openapi-generator
// https://openapi-generator.tech
//

import Foundation
#if canImport(AnyCodable)
import AnyCodable
#endif

public struct DeltaReason: Codable, JSONEncodable, Hashable {

    public var tag: String?
    public var problem: String?
    public var recommendation: String?
    public var modifier: Double?
    public var passed: Bool?
    public var url: String?
    public var mediaKey: String?

    public init(tag: String? = nil, problem: String? = nil, recommendation: String? = nil, modifier: Double? = nil, passed: Bool? = nil, url: String? = nil, mediaKey: String? = nil) {
        self.tag = tag
        self.problem = problem
        self.recommendation = recommendation
        self.modifier = modifier
        self.passed = passed
        self.url = url
        self.mediaKey = mediaKey
    }

    public enum CodingKeys: String, CodingKey, CaseIterable {
        case tag
        case problem
        case recommendation
        case modifier
        case passed
        case url
        case mediaKey
    }

    // Encodable protocol methods

    public func encode(to encoder: Encoder) throws {
        var container = encoder.container(keyedBy: CodingKeys.self)
        try container.encodeIfPresent(tag, forKey: .tag)
        try container.encodeIfPresent(problem, forKey: .problem)
        try container.encodeIfPresent(recommendation, forKey: .recommendation)
        try container.encodeIfPresent(modifier, forKey: .modifier)
        try container.encodeIfPresent(passed, forKey: .passed)
        try container.encodeIfPresent(url, forKey: .url)
        try container.encodeIfPresent(mediaKey, forKey: .mediaKey)
    }
}

